type token =
    ANNOT of (int * string)
  | IDENTIFIER of (string)
  | CONSTANT of (string)
  | STRING_LITERAL of (string)
  | TYPE_NAME of (string)
  | SIZEOF
  | PTR_OP
  | INC_OP
  | DEC_OP
  | LEFT_OP
  | RIGHT_OP
  | LE_OP
  | GE_OP
  | EQ_OP
  | NE_OP
  | AND_OP
  | OR_OP
  | MUL_ASSIGN
  | DIV_ASSIGN
  | MOD_ASSIGN
  | ADD_ASSIGN
  | SUB_ASSIGN
  | LEFT_ASSIGN
  | RIGHT_ASSIGN
  | AND_ASSIGN
  | XOR_ASSIGN
  | OR_ASSIGN
  | TYPEDEF
  | EXTERN
  | STATIC
  | AUTO
  | REGISTER
  | CHAR
  | SHORT
  | INT
  | LONG
  | SIGNED
  | UNSIGNED
  | FLOAT
  | DOUBLE
  | CONST
  | VOLATILE
  | VOID
  | STRUCT
  | UNION
  | ENUM
  | ELLIPSIS
  | CASE
  | DEFAULT
  | IF
  | ELSE
  | SWITCH
  | WHILE
  | DO
  | FOR
  | GOTO
  | CONTINUE
  | BREAK
  | RETURN
  | SEMICOLON
  | LBRACE
  | RBRACE
  | COMMA
  | COLON
  | EQUAL
  | LPAR
  | RPAR
  | LSQUARE
  | RSQUARE
  | DOT
  | AMP
  | EXL
  | TILDE
  | MINUS
  | PLUS
  | STAR
  | SLASH
  | PERCENT
  | LT
  | GT
  | HAT
  | PIPE
  | QUESTION
  | EOF

open Parsing
# 20 "src/cparser.mly"

  open Logic
  open Ptree
  open Cast
  open Parsing

  let loc () = (symbol_start (), symbol_end ())
  let loc_i i = (rhs_start i, rhs_end i)

  let uns () =
    raise (Stdpp.Exc_located (loc (), Stream.Error "Unsupported C syntax"))
  let unss s =
    raise (Stdpp.Exc_located (loc (), 
			      Stream.Error ("Unsupported C syntax: " ^ s)))

  let add_pre_loc lb = function
    | Some (b,_) -> Loc.join (b,0) lb 
    | _ -> lb

  let expr_of_statement = function
    | CSnop l -> CEnop l
    | CSexpr (_, e) -> e
    | _ -> assert false

(* Line 28, file src/cparser.ml *)
let yytransl_const = [|
  262 (* SIZEOF *);
  263 (* PTR_OP *);
  264 (* INC_OP *);
  265 (* DEC_OP *);
  266 (* LEFT_OP *);
  267 (* RIGHT_OP *);
  268 (* LE_OP *);
  269 (* GE_OP *);
  270 (* EQ_OP *);
  271 (* NE_OP *);
  272 (* AND_OP *);
  273 (* OR_OP *);
  274 (* MUL_ASSIGN *);
  275 (* DIV_ASSIGN *);
  276 (* MOD_ASSIGN *);
  277 (* ADD_ASSIGN *);
  278 (* SUB_ASSIGN *);
  279 (* LEFT_ASSIGN *);
  280 (* RIGHT_ASSIGN *);
  281 (* AND_ASSIGN *);
  282 (* XOR_ASSIGN *);
  283 (* OR_ASSIGN *);
  284 (* TYPEDEF *);
  285 (* EXTERN *);
  286 (* STATIC *);
  287 (* AUTO *);
  288 (* REGISTER *);
  289 (* CHAR *);
  290 (* SHORT *);
  291 (* INT *);
  292 (* LONG *);
  293 (* SIGNED *);
  294 (* UNSIGNED *);
  295 (* FLOAT *);
  296 (* DOUBLE *);
  297 (* CONST *);
  298 (* VOLATILE *);
  299 (* VOID *);
  300 (* STRUCT *);
  301 (* UNION *);
  302 (* ENUM *);
  303 (* ELLIPSIS *);
  304 (* CASE *);
  305 (* DEFAULT *);
  306 (* IF *);
  307 (* ELSE *);
  308 (* SWITCH *);
  309 (* WHILE *);
  310 (* DO *);
  311 (* FOR *);
  312 (* GOTO *);
  313 (* CONTINUE *);
  314 (* BREAK *);
  315 (* RETURN *);
  316 (* SEMICOLON *);
  317 (* LBRACE *);
  318 (* RBRACE *);
  319 (* COMMA *);
  320 (* COLON *);
  321 (* EQUAL *);
  322 (* LPAR *);
  323 (* RPAR *);
  324 (* LSQUARE *);
  325 (* RSQUARE *);
  326 (* DOT *);
  327 (* AMP *);
  328 (* EXL *);
  329 (* TILDE *);
  330 (* MINUS *);
  331 (* PLUS *);
  332 (* STAR *);
  333 (* SLASH *);
  334 (* PERCENT *);
  335 (* LT *);
  336 (* GT *);
  337 (* HAT *);
  338 (* PIPE *);
  339 (* QUESTION *);
    0 (* EOF *);
    0|]

let yytransl_block = [|
  257 (* ANNOT *);
  258 (* IDENTIFIER *);
  259 (* CONSTANT *);
  260 (* STRING_LITERAL *);
  261 (* TYPE_NAME *);
    0|]

let yylhs = "\255\255\
\001\000\001\000\003\000\003\000\003\000\003\000\005\000\005\000\
\005\000\005\000\005\000\005\000\005\000\005\000\006\000\006\000\
\008\000\008\000\008\000\008\000\008\000\008\000\009\000\009\000\
\009\000\009\000\009\000\009\000\010\000\010\000\012\000\012\000\
\012\000\012\000\013\000\013\000\013\000\014\000\014\000\014\000\
\015\000\015\000\015\000\015\000\015\000\016\000\016\000\016\000\
\017\000\017\000\018\000\018\000\019\000\019\000\020\000\020\000\
\021\000\021\000\022\000\022\000\007\000\007\000\023\000\023\000\
\023\000\023\000\023\000\023\000\023\000\023\000\023\000\023\000\
\023\000\004\000\004\000\024\000\025\000\025\000\026\000\026\000\
\026\000\026\000\026\000\026\000\027\000\027\000\031\000\031\000\
\028\000\028\000\028\000\028\000\028\000\029\000\029\000\029\000\
\029\000\029\000\029\000\029\000\029\000\029\000\029\000\029\000\
\029\000\034\000\034\000\034\000\036\000\036\000\037\000\037\000\
\038\000\039\000\039\000\039\000\039\000\040\000\040\000\041\000\
\041\000\041\000\035\000\035\000\035\000\042\000\042\000\043\000\
\043\000\030\000\030\000\032\000\032\000\045\000\045\000\045\000\
\045\000\045\000\045\000\045\000\047\000\047\000\044\000\044\000\
\044\000\044\000\049\000\049\000\046\000\046\000\050\000\050\000\
\051\000\051\000\051\000\048\000\048\000\011\000\011\000\052\000\
\052\000\052\000\053\000\053\000\053\000\053\000\053\000\053\000\
\053\000\053\000\053\000\033\000\033\000\033\000\054\000\054\000\
\055\000\055\000\055\000\055\000\055\000\055\000\056\000\056\000\
\056\000\057\000\057\000\057\000\057\000\064\000\063\000\063\000\
\062\000\062\000\058\000\058\000\059\000\059\000\059\000\060\000\
\060\000\060\000\060\000\061\000\061\000\061\000\061\000\061\000\
\002\000\002\000\065\000\065\000\066\000\066\000\066\000\066\000\
\000\000"

let yylen = "\002\000\
\002\000\001\000\001\000\001\000\001\000\003\000\001\000\004\000\
\003\000\004\000\003\000\003\000\002\000\002\000\001\000\003\000\
\001\000\002\000\002\000\002\000\002\000\004\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\004\000\001\000\003\000\
\003\000\003\000\001\000\003\000\003\000\001\000\003\000\003\000\
\001\000\003\000\003\000\003\000\003\000\001\000\003\000\003\000\
\001\000\003\000\001\000\003\000\001\000\003\000\001\000\003\000\
\001\000\003\000\001\000\005\000\001\000\003\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\003\000\001\000\002\000\003\000\001\000\002\000\
\001\000\002\000\001\000\002\000\001\000\003\000\001\000\003\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\005\000\004\000\002\000\001\000\001\000\001\000\002\000\
\003\000\002\000\001\000\002\000\001\000\001\000\003\000\001\000\
\002\000\003\000\004\000\005\000\002\000\001\000\003\000\001\000\
\003\000\001\000\001\000\002\000\001\000\001\000\003\000\004\000\
\003\000\005\000\004\000\004\000\001\000\000\000\001\000\002\000\
\002\000\003\000\001\000\002\000\001\000\003\000\001\000\003\000\
\002\000\002\000\001\000\001\000\003\000\001\000\002\000\001\000\
\001\000\002\000\003\000\002\000\003\000\003\000\004\000\002\000\
\003\000\003\000\004\000\001\000\003\000\004\000\001\000\003\000\
\001\000\001\000\001\000\001\000\001\000\001\000\003\000\004\000\
\003\000\002\000\003\000\003\000\004\000\002\000\001\000\002\000\
\001\000\002\000\001\000\002\000\005\000\007\000\005\000\006\000\
\008\000\007\000\008\000\003\000\002\000\002\000\002\000\003\000\
\001\000\002\000\001\000\001\000\004\000\003\000\003\000\002\000\
\002\000"

let yydefred = "\000\000\
\000\000\000\000\134\000\105\000\089\000\090\000\091\000\092\000\
\093\000\095\000\096\000\097\000\098\000\101\000\102\000\099\000\
\100\000\130\000\131\000\094\000\109\000\110\000\000\000\000\000\
\000\000\002\000\217\000\000\000\212\000\000\000\000\000\000\000\
\000\000\000\000\103\000\104\000\000\000\000\000\000\000\209\000\
\211\000\000\000\000\000\000\000\147\000\145\000\000\000\001\000\
\210\000\077\000\000\000\085\000\000\000\080\000\082\000\084\000\
\000\000\191\000\000\000\216\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\126\000\135\000\148\000\
\146\000\078\000\000\000\000\000\000\000\000\000\214\000\000\000\
\004\000\005\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\195\000\186\000\000\000\023\000\028\000\027\000\026\000\025\000\
\024\000\007\000\000\000\000\000\074\000\000\000\000\000\031\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\061\000\193\000\177\000\178\000\179\000\180\000\
\181\000\182\000\000\000\000\000\000\000\192\000\215\000\000\000\
\000\000\000\000\000\000\111\000\000\000\156\000\000\000\000\000\
\000\000\000\000\000\000\151\000\003\000\137\000\029\000\076\000\
\000\000\000\000\000\000\123\000\000\000\086\000\000\000\172\000\
\088\000\141\000\190\000\213\000\000\000\000\000\021\000\000\000\
\018\000\019\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\205\000\206\000\207\000\000\000\000\000\000\000\
\000\000\196\000\000\000\000\000\013\000\014\000\000\000\000\000\
\000\000\064\000\065\000\066\000\067\000\068\000\069\000\070\000\
\071\000\072\000\073\000\063\000\000\000\020\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\187\000\194\000\188\000\000\000\000\000\114\000\116\000\
\107\000\112\000\000\000\000\000\000\000\118\000\140\000\000\000\
\000\000\153\000\000\000\154\000\000\000\000\000\000\000\139\000\
\000\000\136\000\124\000\129\000\127\000\175\000\000\000\183\000\
\000\000\000\000\185\000\000\000\000\000\000\000\000\000\000\000\
\204\000\208\000\006\000\000\000\000\000\000\000\159\000\075\000\
\012\000\009\000\000\000\015\000\000\000\011\000\062\000\032\000\
\033\000\034\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\189\000\106\000\121\000\000\000\113\000\000\000\
\168\000\000\000\000\000\164\000\000\000\000\000\000\000\000\000\
\138\000\157\000\150\000\152\000\173\000\000\000\022\000\184\000\
\000\000\000\000\000\000\000\000\000\000\030\000\000\000\010\000\
\008\000\000\000\122\000\119\000\169\000\163\000\165\000\170\000\
\000\000\166\000\000\000\174\000\176\000\000\000\199\000\000\000\
\000\000\000\000\000\000\016\000\060\000\171\000\167\000\000\000\
\200\000\000\000\000\000\000\000\198\000\000\000\202\000\000\000\
\201\000\203\000"

let yydgoto = "\002\000\
\027\000\028\000\106\000\107\000\108\000\019\001\109\000\110\000\
\111\000\112\000\184\000\113\000\114\000\115\000\116\000\117\000\
\118\000\119\000\120\000\121\000\122\000\123\000\205\000\153\000\
\058\000\059\000\051\000\031\000\032\000\033\000\052\000\034\000\
\161\000\035\000\036\000\037\000\139\000\140\000\141\000\237\000\
\238\000\069\000\070\000\038\000\039\000\050\001\163\000\146\000\
\047\000\147\000\148\000\051\001\245\000\255\000\124\000\125\000\
\126\000\127\000\128\000\129\000\130\000\131\000\061\000\079\000\
\040\000\041\000"

let yysindex = "\031\000\
\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\048\255\141\255\
\013\255\000\000\000\000\020\000\000\000\137\255\131\007\131\007\
\131\007\069\007\000\000\000\000\050\255\014\255\008\255\000\000\
\000\000\236\254\071\255\045\255\000\000\000\000\013\255\000\000\
\000\000\000\000\249\254\000\000\241\006\000\000\000\000\000\000\
\027\001\000\000\137\255\000\000\069\007\058\255\042\007\008\255\
\077\006\057\255\071\255\102\255\062\255\000\000\000\000\000\000\
\000\000\000\000\141\255\178\002\182\255\069\007\000\000\165\255\
\000\000\000\000\253\002\010\003\010\003\038\003\218\255\154\255\
\009\000\015\000\102\002\022\000\016\000\145\255\030\000\207\002\
\000\000\000\000\177\001\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\077\255\156\255\000\000\099\000\038\003\000\000\
\113\255\171\255\250\255\016\255\129\000\213\255\049\000\057\000\
\079\000\009\255\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\041\002\102\001\081\000\000\000\000\000\042\007\
\042\007\042\007\189\003\000\000\034\255\000\000\182\255\136\255\
\074\000\226\254\127\000\000\000\000\000\000\000\000\000\000\000\
\093\000\098\000\038\003\000\000\071\255\000\000\178\002\000\000\
\000\000\000\000\000\000\000\000\102\002\177\001\000\000\038\003\
\000\000\000\000\131\000\102\002\038\003\038\003\038\003\203\000\
\239\002\153\000\000\000\000\000\000\000\121\255\237\254\148\000\
\252\254\000\000\038\003\224\000\000\000\000\000\125\000\038\003\
\227\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\038\003\000\000\038\003\038\003\
\038\003\038\003\038\003\038\003\038\003\038\003\038\003\038\003\
\038\003\038\003\038\003\038\003\038\003\038\003\038\003\038\003\
\038\003\000\000\000\000\000\000\071\002\027\007\000\000\000\000\
\000\000\000\000\038\003\167\000\155\255\000\000\000\000\162\002\
\043\001\000\000\142\255\000\000\019\255\182\255\232\000\000\000\
\111\007\000\000\000\000\000\000\000\000\000\000\104\000\000\000\
\181\000\102\002\000\000\158\255\180\255\190\255\198\000\239\002\
\000\000\000\000\000\000\038\003\223\004\002\000\000\000\000\000\
\000\000\000\000\203\255\000\000\227\254\000\000\000\000\000\000\
\000\000\000\000\113\255\113\255\171\255\171\255\250\255\250\255\
\250\255\250\255\016\255\016\255\129\000\213\255\049\000\057\000\
\079\000\130\000\000\000\000\000\000\000\038\003\000\000\034\255\
\000\000\185\000\186\000\000\000\190\000\019\255\222\006\118\001\
\000\000\000\000\000\000\000\000\000\000\076\000\000\000\000\000\
\102\002\102\002\253\000\189\000\218\002\000\000\038\003\000\000\
\000\000\038\003\000\000\000\000\000\000\000\000\000\000\000\000\
\204\000\000\000\206\000\000\000\000\000\221\000\000\000\102\002\
\038\003\016\001\208\255\000\000\000\000\000\000\000\000\102\002\
\000\000\210\255\102\002\019\001\000\000\217\000\000\000\102\002\
\000\000\000\000"

let yyrindex = "\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\119\255\000\000\000\000\000\000\000\000\000\000\015\255\133\255\
\029\003\000\000\000\000\000\000\000\000\000\000\138\006\000\000\
\000\000\196\001\000\000\000\000\000\000\000\000\164\255\000\000\
\000\000\000\000\000\000\000\000\216\255\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\252\001\000\000\180\006\
\000\000\000\000\000\000\140\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\069\000\000\000\000\000\162\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\105\003\000\000\129\003\000\000\000\000\
\203\003\069\004\002\005\150\005\007\004\218\005\250\005\090\003\
\032\004\175\255\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\216\255\000\000\000\000\000\000\
\089\000\201\001\000\000\000\000\000\000\000\000\096\006\026\000\
\000\000\000\000\211\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\223\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\013\000\000\000\000\000\000\000\000\000\
\000\000\000\000\073\000\000\000\091\000\096\006\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\226\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\227\003\045\004\143\004\167\004\032\005\062\005\
\092\005\122\005\180\005\208\005\105\004\242\005\011\006\185\003\
\130\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\096\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\208\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000"

let yygindex = "\000\000\
\000\000\000\000\000\000\003\000\000\000\000\000\187\255\194\255\
\000\000\163\255\128\001\013\001\034\001\004\001\031\001\075\001\
\076\001\074\001\077\001\080\001\000\000\195\255\000\000\209\255\
\010\000\014\000\000\000\000\000\224\255\069\001\223\001\232\255\
\110\255\000\000\000\000\000\000\170\001\129\255\176\255\000\000\
\005\001\243\001\173\001\239\255\227\255\193\255\123\255\000\000\
\000\000\000\000\085\001\139\255\083\255\000\000\168\255\000\000\
\158\000\093\255\000\000\000\000\000\000\214\001\030\001\000\000\
\063\002\000\000"

let yytablesize = 2225
let yytable = "\044\000\
\026\000\145\000\176\000\151\000\152\000\053\000\160\000\046\000\
\064\000\239\000\029\000\234\000\254\000\008\001\030\000\003\000\
\079\000\206\000\185\000\048\000\167\000\169\000\170\000\151\000\
\152\000\224\000\244\000\214\000\215\000\073\000\137\000\001\000\
\247\000\187\000\133\000\003\000\248\000\029\000\171\000\073\001\
\067\000\030\000\227\000\187\000\054\000\055\000\056\000\011\001\
\151\000\042\000\133\000\062\000\074\000\018\000\019\000\075\000\
\231\000\232\000\149\000\081\000\082\000\013\001\083\000\241\000\
\084\000\085\000\137\000\015\001\142\000\054\001\134\000\025\000\
\068\000\065\000\079\000\066\000\000\001\079\000\144\000\024\000\
\079\000\079\000\079\000\003\001\055\001\185\000\056\001\134\000\
\025\000\160\000\079\000\225\000\151\000\152\000\216\000\217\000\
\054\001\235\000\182\000\024\000\069\001\183\000\234\000\137\000\
\137\000\137\000\137\000\252\000\043\000\025\000\063\000\071\000\
\057\001\024\001\025\001\026\001\236\000\016\001\136\000\242\000\
\143\000\020\001\099\000\156\000\157\000\150\000\243\000\100\000\
\101\000\102\000\103\000\104\000\105\000\137\000\081\000\023\001\
\186\000\003\000\003\000\187\000\227\000\134\000\003\000\003\000\
\151\000\151\000\151\000\151\000\151\000\151\000\151\000\151\000\
\151\000\151\000\151\000\151\000\151\000\151\000\151\000\151\000\
\151\000\151\000\188\000\189\000\190\000\144\000\155\000\014\001\
\183\000\064\001\183\000\085\001\151\000\152\000\070\001\004\001\
\005\001\006\001\151\000\152\000\010\001\143\000\162\000\187\000\
\143\000\143\000\143\000\045\001\207\000\208\000\209\000\060\000\
\081\000\053\001\021\001\081\000\050\000\137\000\081\000\081\000\
\081\000\240\000\024\000\241\000\179\000\151\000\024\000\240\000\
\081\000\241\000\077\000\025\000\025\000\064\000\047\001\044\000\
\025\000\048\001\135\000\173\000\187\000\191\000\243\000\192\000\
\065\001\193\000\144\000\042\001\165\000\144\000\144\000\144\000\
\086\001\087\001\059\000\164\000\059\000\059\000\059\000\151\000\
\152\000\059\000\187\000\059\000\210\000\211\000\066\001\081\001\
\160\000\151\000\152\000\014\001\187\000\144\000\075\001\097\001\
\067\001\092\001\003\000\212\000\213\000\004\000\144\000\101\001\
\083\001\071\001\103\001\151\000\093\001\072\001\187\000\106\001\
\187\000\178\000\100\001\087\000\102\001\003\000\087\000\236\000\
\004\000\172\000\144\000\220\000\005\000\006\000\007\000\008\000\
\009\000\010\000\011\000\012\000\013\000\014\000\015\000\016\000\
\017\000\018\000\019\000\020\000\021\000\022\000\023\000\005\000\
\006\000\007\000\008\000\009\000\010\000\011\000\012\000\013\000\
\014\000\015\000\016\000\017\000\018\000\019\000\020\000\021\000\
\022\000\023\000\024\000\013\001\144\000\241\000\142\000\091\001\
\120\000\142\000\174\000\120\000\025\000\149\000\081\000\082\000\
\175\000\083\000\078\000\084\000\085\000\024\000\132\000\177\000\
\155\000\180\000\115\000\098\001\155\000\045\000\223\000\025\000\
\142\000\142\000\142\000\142\000\142\000\142\000\142\000\142\000\
\142\000\142\000\142\000\142\000\142\000\142\000\142\000\142\000\
\142\000\142\000\142\000\072\000\194\000\195\000\196\000\197\000\
\198\000\199\000\200\000\201\000\202\000\203\000\149\000\081\000\
\082\000\221\000\083\000\138\000\084\000\085\000\142\000\160\000\
\159\000\084\001\222\000\160\000\246\000\099\000\218\000\219\000\
\142\000\076\000\100\000\101\000\102\000\103\000\104\000\105\000\
\115\000\161\000\115\000\115\000\115\000\161\000\162\000\251\000\
\157\000\250\000\162\000\204\000\115\000\061\001\062\001\138\000\
\003\000\003\000\003\000\003\000\003\000\003\000\003\000\003\000\
\003\000\003\000\003\000\003\000\003\000\003\000\003\000\003\000\
\003\000\003\000\003\000\003\000\003\000\249\000\099\000\018\001\
\187\000\074\001\002\001\100\000\101\000\102\000\103\000\104\000\
\105\000\128\000\128\000\007\001\138\000\138\000\138\000\138\000\
\197\000\197\000\197\000\197\000\009\001\197\000\012\001\197\000\
\197\000\031\001\032\001\033\001\034\001\003\000\027\001\028\001\
\003\000\017\001\003\000\003\000\022\001\003\000\046\001\003\000\
\003\000\058\001\138\000\003\000\003\000\003\000\003\000\003\000\
\003\000\003\000\003\000\003\000\003\000\029\001\030\001\063\001\
\035\001\036\001\068\001\077\001\078\001\088\001\089\001\197\000\
\197\000\197\000\079\001\197\000\197\000\197\000\197\000\197\000\
\197\000\197\000\197\000\197\000\197\000\197\000\094\001\096\001\
\099\001\197\000\095\001\104\001\105\001\149\000\197\000\197\000\
\197\000\197\000\197\000\197\000\080\000\081\000\082\000\004\000\
\083\000\158\000\084\000\085\000\160\000\001\001\037\001\039\001\
\038\001\158\000\138\000\040\001\149\000\081\000\082\000\041\001\
\083\000\230\000\084\000\085\000\076\001\154\000\005\000\006\000\
\007\000\008\000\009\000\010\000\011\000\012\000\013\000\014\000\
\015\000\016\000\017\000\018\000\019\000\020\000\021\000\022\000\
\023\000\253\000\086\000\087\000\088\000\060\001\089\000\090\000\
\091\000\092\000\093\000\094\000\095\000\096\000\097\000\057\000\
\098\000\229\000\049\000\000\000\099\000\000\000\000\000\000\000\
\000\000\100\000\101\000\102\000\103\000\104\000\105\000\080\000\
\081\000\082\000\004\000\083\000\099\000\084\000\085\000\052\001\
\000\000\100\000\101\000\102\000\103\000\104\000\105\000\149\000\
\081\000\082\000\000\000\083\000\000\000\084\000\085\000\000\000\
\000\000\005\000\006\000\007\000\008\000\009\000\010\000\011\000\
\012\000\013\000\014\000\015\000\016\000\017\000\018\000\019\000\
\020\000\021\000\022\000\023\000\000\000\086\000\087\000\088\000\
\000\000\089\000\090\000\091\000\092\000\093\000\094\000\095\000\
\096\000\097\000\057\000\228\000\000\000\000\000\000\000\099\000\
\000\000\000\000\000\000\000\000\100\000\101\000\102\000\103\000\
\104\000\105\000\149\000\081\000\082\000\004\000\083\000\099\000\
\084\000\085\000\082\001\000\000\100\000\101\000\102\000\103\000\
\104\000\105\000\000\000\000\000\000\000\125\000\000\000\000\000\
\125\000\000\000\117\000\000\000\000\000\000\000\000\000\000\000\
\000\000\010\000\011\000\012\000\013\000\014\000\015\000\016\000\
\017\000\018\000\019\000\020\000\021\000\022\000\023\000\125\000\
\125\000\125\000\125\000\125\000\125\000\125\000\125\000\125\000\
\125\000\125\000\125\000\125\000\125\000\125\000\125\000\125\000\
\125\000\125\000\099\000\000\000\000\000\000\000\000\000\100\000\
\101\000\102\000\103\000\104\000\105\000\108\000\000\000\125\000\
\108\000\000\000\125\000\125\000\000\000\125\000\125\000\125\000\
\117\000\000\000\117\000\117\000\117\000\000\000\000\000\125\000\
\000\000\000\000\000\000\000\000\117\000\000\000\000\000\108\000\
\108\000\108\000\108\000\108\000\108\000\108\000\108\000\108\000\
\108\000\108\000\108\000\108\000\108\000\108\000\108\000\108\000\
\108\000\108\000\080\000\081\000\082\000\000\000\083\000\000\000\
\084\000\085\000\000\000\000\000\000\000\000\000\000\000\108\000\
\000\000\000\000\108\000\108\000\000\000\108\000\108\000\108\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\108\000\
\080\000\081\000\082\000\000\000\083\000\000\000\084\000\085\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\086\000\087\000\088\000\000\000\089\000\090\000\091\000\092\000\
\093\000\094\000\095\000\096\000\097\000\057\000\226\000\080\000\
\081\000\082\000\099\000\083\000\000\000\084\000\085\000\100\000\
\101\000\102\000\103\000\104\000\105\000\000\000\086\000\087\000\
\088\000\000\000\089\000\090\000\091\000\092\000\093\000\094\000\
\095\000\096\000\097\000\057\000\043\001\000\000\000\000\000\000\
\099\000\000\000\000\000\000\000\000\000\100\000\101\000\102\000\
\103\000\104\000\105\000\000\000\000\000\086\000\087\000\088\000\
\000\000\089\000\090\000\091\000\092\000\093\000\094\000\095\000\
\096\000\097\000\057\000\003\000\000\000\000\000\004\000\099\000\
\000\000\000\000\000\000\000\000\100\000\101\000\102\000\103\000\
\104\000\105\000\000\000\149\000\081\000\082\000\000\000\083\000\
\000\000\084\000\085\000\000\000\000\000\005\000\006\000\007\000\
\008\000\009\000\010\000\011\000\012\000\013\000\014\000\015\000\
\016\000\017\000\018\000\019\000\020\000\021\000\022\000\023\000\
\149\000\081\000\082\000\000\000\083\000\000\000\084\000\085\000\
\000\000\000\000\000\000\149\000\081\000\082\000\000\000\083\000\
\000\000\084\000\085\000\240\000\049\001\241\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\025\000\159\000\000\000\
\149\000\081\000\082\000\099\000\083\000\000\000\084\000\085\000\
\100\000\101\000\102\000\103\000\104\000\105\000\149\000\081\000\
\082\000\000\000\083\000\000\000\084\000\085\000\000\000\000\000\
\000\000\000\000\181\000\149\000\081\000\082\000\000\000\083\000\
\099\000\084\000\085\000\000\000\000\000\100\000\101\000\102\000\
\103\000\104\000\105\000\099\000\090\001\000\000\083\000\000\000\
\100\000\101\000\102\000\103\000\104\000\105\000\000\000\149\000\
\081\000\082\000\097\000\083\000\000\000\084\000\085\000\000\000\
\099\000\000\000\000\000\000\000\000\000\100\000\101\000\102\000\
\103\000\104\000\105\000\000\000\000\000\000\000\166\000\000\000\
\000\000\000\000\000\000\100\000\101\000\102\000\103\000\104\000\
\105\000\000\000\000\000\168\000\000\000\000\000\000\000\000\000\
\100\000\101\000\102\000\103\000\104\000\105\000\000\000\000\000\
\083\000\000\000\000\000\083\000\000\000\000\000\083\000\083\000\
\083\000\000\000\000\000\000\000\000\000\000\000\000\000\099\000\
\083\000\055\000\055\000\000\000\100\000\101\000\102\000\103\000\
\104\000\105\000\017\000\017\000\017\000\017\000\017\000\017\000\
\017\000\017\000\017\000\017\000\017\000\017\000\017\000\017\000\
\017\000\017\000\017\000\017\000\000\000\000\000\000\000\000\000\
\000\000\000\000\029\000\029\000\029\000\029\000\029\000\029\000\
\029\000\029\000\000\000\000\000\000\000\055\000\000\000\055\000\
\055\000\055\000\000\000\000\000\055\000\000\000\055\000\000\000\
\000\000\000\000\000\000\000\000\017\000\000\000\017\000\017\000\
\017\000\017\000\000\000\017\000\055\000\017\000\000\000\017\000\
\000\000\000\000\017\000\017\000\017\000\017\000\017\000\017\000\
\017\000\017\000\017\000\017\000\029\000\000\000\029\000\029\000\
\029\000\004\000\000\000\029\000\000\000\029\000\000\000\029\000\
\056\000\056\000\029\000\029\000\029\000\029\000\029\000\029\000\
\029\000\029\000\029\000\029\000\035\000\035\000\035\000\035\000\
\035\000\035\000\035\000\035\000\000\000\010\000\011\000\012\000\
\013\000\014\000\015\000\016\000\017\000\018\000\019\000\020\000\
\021\000\022\000\023\000\000\000\037\000\037\000\037\000\037\000\
\037\000\037\000\037\000\037\000\056\000\000\000\056\000\056\000\
\056\000\000\000\233\000\056\000\000\000\056\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\035\000\000\000\
\035\000\035\000\035\000\056\000\000\000\035\000\000\000\035\000\
\000\000\035\000\000\000\000\000\035\000\035\000\049\000\049\000\
\000\000\035\000\035\000\035\000\035\000\035\000\037\000\000\000\
\037\000\037\000\037\000\000\000\000\000\037\000\000\000\037\000\
\000\000\037\000\000\000\000\000\037\000\037\000\000\000\000\000\
\057\000\037\000\037\000\037\000\037\000\037\000\036\000\036\000\
\036\000\036\000\036\000\036\000\036\000\036\000\000\000\000\000\
\000\000\000\000\049\000\000\000\049\000\049\000\049\000\000\000\
\000\000\049\000\000\000\049\000\000\000\049\000\038\000\038\000\
\038\000\038\000\038\000\038\000\038\000\038\000\000\000\049\000\
\049\000\049\000\000\000\057\000\000\000\057\000\057\000\057\000\
\000\000\000\000\057\000\000\000\057\000\000\000\000\000\000\000\
\036\000\000\000\036\000\036\000\036\000\000\000\000\000\036\000\
\000\000\036\000\057\000\036\000\000\000\000\000\036\000\036\000\
\050\000\050\000\000\000\036\000\036\000\036\000\036\000\036\000\
\038\000\000\000\038\000\038\000\038\000\000\000\000\000\038\000\
\000\000\038\000\000\000\038\000\000\000\000\000\000\000\000\000\
\000\000\000\000\058\000\038\000\038\000\038\000\038\000\038\000\
\039\000\039\000\039\000\039\000\039\000\039\000\039\000\039\000\
\000\000\000\000\000\000\000\000\050\000\000\000\050\000\050\000\
\050\000\000\000\000\000\050\000\000\000\050\000\000\000\050\000\
\040\000\040\000\040\000\040\000\040\000\040\000\040\000\040\000\
\000\000\050\000\050\000\050\000\000\000\058\000\000\000\058\000\
\058\000\058\000\000\000\000\000\058\000\000\000\058\000\000\000\
\000\000\000\000\039\000\000\000\039\000\039\000\039\000\000\000\
\000\000\039\000\000\000\039\000\058\000\039\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\039\000\039\000\039\000\
\039\000\039\000\040\000\004\000\040\000\040\000\040\000\000\000\
\000\000\040\000\000\000\040\000\000\000\040\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\040\000\040\000\040\000\
\040\000\040\000\005\000\006\000\007\000\008\000\009\000\010\000\
\011\000\012\000\013\000\014\000\015\000\016\000\017\000\018\000\
\019\000\020\000\021\000\022\000\023\000\041\000\041\000\041\000\
\041\000\041\000\041\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\013\001\049\001\241\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\025\000\044\000\044\000\044\000\044\000\044\000\
\044\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\041\000\000\000\041\000\
\041\000\041\000\000\000\000\000\041\000\000\000\041\000\000\000\
\041\000\045\000\045\000\045\000\045\000\045\000\045\000\000\000\
\041\000\041\000\041\000\041\000\041\000\000\000\000\000\000\000\
\000\000\000\000\000\000\044\000\000\000\044\000\044\000\044\000\
\000\000\000\000\044\000\000\000\044\000\000\000\044\000\042\000\
\042\000\042\000\042\000\042\000\042\000\000\000\044\000\044\000\
\044\000\044\000\044\000\000\000\000\000\000\000\000\000\000\000\
\000\000\045\000\000\000\045\000\045\000\045\000\000\000\000\000\
\045\000\000\000\045\000\000\000\045\000\043\000\043\000\043\000\
\043\000\043\000\043\000\000\000\045\000\045\000\045\000\045\000\
\045\000\000\000\000\000\000\000\000\000\000\000\000\000\042\000\
\000\000\042\000\042\000\042\000\000\000\000\000\042\000\000\000\
\042\000\000\000\042\000\046\000\046\000\046\000\046\000\000\000\
\000\000\000\000\042\000\042\000\042\000\042\000\042\000\000\000\
\000\000\000\000\000\000\000\000\000\000\043\000\000\000\043\000\
\043\000\043\000\000\000\000\000\043\000\000\000\043\000\000\000\
\043\000\047\000\047\000\047\000\047\000\000\000\000\000\000\000\
\043\000\043\000\043\000\043\000\043\000\000\000\000\000\000\000\
\000\000\046\000\000\000\046\000\046\000\046\000\000\000\000\000\
\046\000\000\000\046\000\000\000\046\000\048\000\048\000\048\000\
\048\000\000\000\000\000\000\000\000\000\000\000\046\000\046\000\
\046\000\051\000\051\000\000\000\000\000\000\000\000\000\047\000\
\000\000\047\000\047\000\047\000\000\000\000\000\047\000\000\000\
\047\000\000\000\047\000\000\000\000\000\000\000\000\000\000\000\
\000\000\052\000\052\000\000\000\047\000\047\000\047\000\000\000\
\000\000\053\000\053\000\048\000\000\000\048\000\048\000\048\000\
\000\000\000\000\048\000\000\000\048\000\051\000\048\000\051\000\
\051\000\051\000\054\000\054\000\051\000\000\000\051\000\000\000\
\048\000\048\000\048\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\051\000\051\000\051\000\052\000\000\000\052\000\
\052\000\052\000\000\000\000\000\052\000\053\000\052\000\053\000\
\053\000\053\000\000\000\000\000\053\000\000\000\053\000\000\000\
\000\000\000\000\052\000\052\000\052\000\000\000\054\000\000\000\
\054\000\054\000\054\000\053\000\053\000\054\000\142\000\054\000\
\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\054\000\054\000\000\000\000\000\
\000\000\000\000\000\000\000\000\142\000\000\000\000\000\000\000\
\005\000\006\000\007\000\008\000\009\000\010\000\011\000\012\000\
\013\000\014\000\015\000\016\000\017\000\018\000\019\000\020\000\
\021\000\022\000\023\000\142\000\142\000\142\000\142\000\142\000\
\142\000\142\000\142\000\142\000\142\000\142\000\142\000\142\000\
\142\000\142\000\142\000\142\000\142\000\142\000\133\000\143\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\142\000\142\000\000\000\142\000\142\000\
\142\000\142\000\142\000\142\000\000\000\133\000\133\000\133\000\
\133\000\133\000\133\000\133\000\133\000\133\000\133\000\133\000\
\133\000\133\000\133\000\133\000\133\000\133\000\133\000\133\000\
\132\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\133\000\133\000\000\000\
\133\000\133\000\133\000\000\000\133\000\000\000\000\000\132\000\
\132\000\132\000\132\000\132\000\132\000\132\000\132\000\132\000\
\132\000\132\000\132\000\132\000\132\000\132\000\132\000\132\000\
\132\000\132\000\004\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\132\000\
\132\000\000\000\132\000\132\000\132\000\004\000\132\000\000\000\
\000\000\005\000\006\000\007\000\008\000\009\000\010\000\011\000\
\012\000\013\000\014\000\015\000\016\000\017\000\018\000\019\000\
\020\000\021\000\022\000\023\000\005\000\006\000\007\000\008\000\
\009\000\010\000\011\000\012\000\013\000\014\000\015\000\016\000\
\017\000\018\000\019\000\020\000\021\000\022\000\023\000\004\000\
\080\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\057\000\004\000\000\000\
\000\000\076\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\010\000\011\000\012\000\013\000\014\000\
\015\000\016\000\017\000\018\000\019\000\020\000\021\000\022\000\
\023\000\004\000\010\000\011\000\012\000\013\000\014\000\015\000\
\016\000\017\000\018\000\019\000\020\000\021\000\022\000\023\000\
\044\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\005\000\006\000\007\000\008\000\009\000\010\000\011\000\012\000\
\013\000\014\000\015\000\016\000\017\000\018\000\019\000\020\000\
\021\000\022\000\023\000\004\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\057\000\000\000\000\000\000\000\000\000\000\000\004\000\
\000\000\000\000\005\000\006\000\007\000\008\000\009\000\010\000\
\011\000\012\000\013\000\014\000\015\000\016\000\017\000\018\000\
\019\000\020\000\021\000\022\000\023\000\059\001\005\000\006\000\
\007\000\008\000\009\000\010\000\011\000\012\000\013\000\014\000\
\015\000\016\000\017\000\018\000\019\000\020\000\021\000\022\000\
\023\000"

let yycheck = "\024\000\
\000\000\065\000\091\000\066\000\066\000\030\000\076\000\025\000\
\038\000\143\000\001\000\139\000\159\000\177\000\001\000\002\001\
\002\001\111\000\099\000\000\000\083\000\084\000\085\000\086\000\
\086\000\017\001\144\000\012\001\013\001\047\000\063\000\001\000\
\063\001\063\001\059\000\002\001\067\001\028\000\086\000\069\001\
\061\001\028\000\131\000\063\001\031\000\032\000\033\000\067\001\
\111\000\002\001\075\000\002\001\060\001\041\001\042\001\063\001\
\137\000\138\000\002\001\003\001\004\001\066\001\006\001\068\001\
\008\001\009\001\099\000\185\000\000\000\243\000\061\000\076\001\
\002\001\066\001\060\001\068\001\165\000\063\001\065\000\066\001\
\066\001\067\001\068\001\172\000\066\001\166\000\068\001\078\000\
\076\001\159\000\076\001\083\001\155\000\155\000\079\001\080\001\
\014\001\064\001\096\000\066\001\008\001\099\000\230\000\136\000\
\137\000\138\000\139\000\155\000\061\001\076\001\061\001\067\001\
\246\000\207\000\208\000\209\000\141\000\187\000\061\001\144\000\
\002\001\191\000\066\001\062\001\063\001\069\001\144\000\071\001\
\072\001\073\001\074\001\075\001\076\001\166\000\002\001\205\000\
\060\001\002\001\002\001\063\001\229\000\132\000\002\001\002\001\
\207\000\208\000\209\000\210\000\211\000\212\000\213\000\214\000\
\215\000\216\000\217\000\218\000\219\000\220\000\221\000\222\000\
\223\000\224\000\007\001\008\001\009\001\002\001\065\001\185\000\
\166\000\002\001\168\000\062\001\235\000\235\000\012\001\173\000\
\174\000\175\000\241\000\241\000\060\001\063\001\001\001\063\001\
\066\001\067\001\068\001\235\000\076\001\077\001\078\001\034\000\
\060\001\241\000\192\000\063\001\060\001\230\000\066\001\067\001\
\068\001\066\001\066\001\068\001\060\001\012\001\066\001\066\001\
\076\001\068\001\053\000\076\001\076\001\243\000\060\001\240\000\
\076\001\063\001\061\000\066\001\063\001\066\001\240\000\068\001\
\067\001\070\001\063\001\225\000\064\001\066\001\067\001\068\001\
\065\001\066\001\060\001\078\000\062\001\063\001\064\001\046\001\
\046\001\067\001\063\001\069\001\074\001\075\001\067\001\055\001\
\062\001\056\001\056\001\013\001\063\001\240\000\046\001\088\001\
\067\001\071\001\002\001\010\001\011\001\005\001\249\000\096\001\
\056\001\063\001\099\001\074\001\074\001\067\001\063\001\104\001\
\063\001\002\001\067\001\060\001\067\001\002\001\063\001\048\001\
\005\001\064\001\013\001\071\001\028\001\029\001\030\001\031\001\
\032\001\033\001\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\028\001\
\029\001\030\001\031\001\032\001\033\001\034\001\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\066\001\066\001\055\001\068\001\002\001\069\001\
\060\001\005\001\066\001\063\001\076\001\002\001\003\001\004\001\
\066\001\006\001\053\000\008\001\009\001\066\001\057\000\066\001\
\063\001\060\001\002\001\089\001\067\001\025\000\016\001\076\001\
\028\001\029\001\030\001\031\001\032\001\033\001\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\000\018\001\019\001\020\001\021\001\
\022\001\023\001\024\001\025\001\026\001\027\001\002\001\003\001\
\004\001\081\001\006\001\063\000\008\001\009\001\066\001\063\001\
\061\001\062\001\082\001\067\001\067\001\066\001\014\001\015\001\
\076\001\065\001\071\001\072\001\073\001\074\001\075\001\076\001\
\064\001\063\001\066\001\067\001\068\001\067\001\063\001\062\001\
\063\001\069\001\067\001\065\001\076\001\062\001\063\001\099\000\
\007\001\008\001\009\001\010\001\011\001\012\001\013\001\014\001\
\015\001\016\001\017\001\018\001\019\001\020\001\021\001\022\001\
\023\001\024\001\025\001\026\001\027\001\063\001\066\001\067\001\
\063\001\064\001\064\001\071\001\072\001\073\001\074\001\075\001\
\076\001\062\001\063\001\001\001\136\000\137\000\138\000\139\000\
\001\001\002\001\003\001\004\001\060\001\006\001\067\001\008\001\
\009\001\214\000\215\000\216\000\217\000\060\001\210\000\211\000\
\063\001\002\001\065\001\066\001\002\001\068\001\064\001\070\001\
\071\001\002\001\166\000\074\001\075\001\076\001\077\001\078\001\
\079\001\080\001\081\001\082\001\083\001\212\000\213\000\067\001\
\218\000\219\000\053\001\067\001\067\001\001\001\066\001\048\001\
\049\001\050\001\069\001\052\001\053\001\054\001\055\001\056\001\
\057\001\058\001\059\001\060\001\061\001\062\001\067\001\051\001\
\001\001\066\001\069\001\001\001\060\001\067\001\071\001\072\001\
\073\001\074\001\075\001\076\001\002\001\003\001\004\001\005\001\
\006\001\067\001\008\001\009\001\067\001\166\000\220\000\222\000\
\221\000\075\000\230\000\223\000\002\001\003\001\004\001\224\000\
\006\001\136\000\008\001\009\001\048\001\067\000\028\001\029\001\
\030\001\031\001\032\001\033\001\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\157\000\048\001\049\001\050\001\249\000\052\001\053\001\
\054\001\055\001\056\001\057\001\058\001\059\001\060\001\061\001\
\062\001\132\000\028\000\255\255\066\001\255\255\255\255\255\255\
\255\255\071\001\072\001\073\001\074\001\075\001\076\001\002\001\
\003\001\004\001\005\001\006\001\066\001\008\001\009\001\069\001\
\255\255\071\001\072\001\073\001\074\001\075\001\076\001\002\001\
\003\001\004\001\255\255\006\001\255\255\008\001\009\001\255\255\
\255\255\028\001\029\001\030\001\031\001\032\001\033\001\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\255\255\048\001\049\001\050\001\
\255\255\052\001\053\001\054\001\055\001\056\001\057\001\058\001\
\059\001\060\001\061\001\062\001\255\255\255\255\255\255\066\001\
\255\255\255\255\255\255\255\255\071\001\072\001\073\001\074\001\
\075\001\076\001\002\001\003\001\004\001\005\001\006\001\066\001\
\008\001\009\001\069\001\255\255\071\001\072\001\073\001\074\001\
\075\001\076\001\255\255\255\255\255\255\002\001\255\255\255\255\
\005\001\255\255\002\001\255\255\255\255\255\255\255\255\255\255\
\255\255\033\001\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\028\001\
\029\001\030\001\031\001\032\001\033\001\034\001\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\066\001\255\255\255\255\255\255\255\255\071\001\
\072\001\073\001\074\001\075\001\076\001\002\001\255\255\060\001\
\005\001\255\255\063\001\064\001\255\255\066\001\067\001\068\001\
\064\001\255\255\066\001\067\001\068\001\255\255\255\255\076\001\
\255\255\255\255\255\255\255\255\076\001\255\255\255\255\028\001\
\029\001\030\001\031\001\032\001\033\001\034\001\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\002\001\003\001\004\001\255\255\006\001\255\255\
\008\001\009\001\255\255\255\255\255\255\255\255\255\255\060\001\
\255\255\255\255\063\001\064\001\255\255\066\001\067\001\068\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\076\001\
\002\001\003\001\004\001\255\255\006\001\255\255\008\001\009\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\048\001\049\001\050\001\255\255\052\001\053\001\054\001\055\001\
\056\001\057\001\058\001\059\001\060\001\061\001\062\001\002\001\
\003\001\004\001\066\001\006\001\255\255\008\001\009\001\071\001\
\072\001\073\001\074\001\075\001\076\001\255\255\048\001\049\001\
\050\001\255\255\052\001\053\001\054\001\055\001\056\001\057\001\
\058\001\059\001\060\001\061\001\062\001\255\255\255\255\255\255\
\066\001\255\255\255\255\255\255\255\255\071\001\072\001\073\001\
\074\001\075\001\076\001\255\255\255\255\048\001\049\001\050\001\
\255\255\052\001\053\001\054\001\055\001\056\001\057\001\058\001\
\059\001\060\001\061\001\002\001\255\255\255\255\005\001\066\001\
\255\255\255\255\255\255\255\255\071\001\072\001\073\001\074\001\
\075\001\076\001\255\255\002\001\003\001\004\001\255\255\006\001\
\255\255\008\001\009\001\255\255\255\255\028\001\029\001\030\001\
\031\001\032\001\033\001\034\001\035\001\036\001\037\001\038\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\002\001\003\001\004\001\255\255\006\001\255\255\008\001\009\001\
\255\255\255\255\255\255\002\001\003\001\004\001\255\255\006\001\
\255\255\008\001\009\001\066\001\067\001\068\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\076\001\061\001\255\255\
\002\001\003\001\004\001\066\001\006\001\255\255\008\001\009\001\
\071\001\072\001\073\001\074\001\075\001\076\001\002\001\003\001\
\004\001\255\255\006\001\255\255\008\001\009\001\255\255\255\255\
\255\255\255\255\060\001\002\001\003\001\004\001\255\255\006\001\
\066\001\008\001\009\001\255\255\255\255\071\001\072\001\073\001\
\074\001\075\001\076\001\066\001\067\001\255\255\002\001\255\255\
\071\001\072\001\073\001\074\001\075\001\076\001\255\255\002\001\
\003\001\004\001\060\001\006\001\255\255\008\001\009\001\255\255\
\066\001\255\255\255\255\255\255\255\255\071\001\072\001\073\001\
\074\001\075\001\076\001\255\255\255\255\255\255\066\001\255\255\
\255\255\255\255\255\255\071\001\072\001\073\001\074\001\075\001\
\076\001\255\255\255\255\066\001\255\255\255\255\255\255\255\255\
\071\001\072\001\073\001\074\001\075\001\076\001\255\255\255\255\
\060\001\255\255\255\255\063\001\255\255\255\255\066\001\067\001\
\068\001\255\255\255\255\255\255\255\255\255\255\255\255\066\001\
\076\001\016\001\017\001\255\255\071\001\072\001\073\001\074\001\
\075\001\076\001\010\001\011\001\012\001\013\001\014\001\015\001\
\016\001\017\001\018\001\019\001\020\001\021\001\022\001\023\001\
\024\001\025\001\026\001\027\001\255\255\255\255\255\255\255\255\
\255\255\255\255\010\001\011\001\012\001\013\001\014\001\015\001\
\016\001\017\001\255\255\255\255\255\255\060\001\255\255\062\001\
\063\001\064\001\255\255\255\255\067\001\255\255\069\001\255\255\
\255\255\255\255\255\255\255\255\060\001\255\255\062\001\063\001\
\064\001\065\001\255\255\067\001\083\001\069\001\255\255\071\001\
\255\255\255\255\074\001\075\001\076\001\077\001\078\001\079\001\
\080\001\081\001\082\001\083\001\060\001\255\255\062\001\063\001\
\064\001\005\001\255\255\067\001\255\255\069\001\255\255\071\001\
\016\001\017\001\074\001\075\001\076\001\077\001\078\001\079\001\
\080\001\081\001\082\001\083\001\010\001\011\001\012\001\013\001\
\014\001\015\001\016\001\017\001\255\255\033\001\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\255\255\010\001\011\001\012\001\013\001\
\014\001\015\001\016\001\017\001\060\001\255\255\062\001\063\001\
\064\001\255\255\062\001\067\001\255\255\069\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\060\001\255\255\
\062\001\063\001\064\001\083\001\255\255\067\001\255\255\069\001\
\255\255\071\001\255\255\255\255\074\001\075\001\016\001\017\001\
\255\255\079\001\080\001\081\001\082\001\083\001\060\001\255\255\
\062\001\063\001\064\001\255\255\255\255\067\001\255\255\069\001\
\255\255\071\001\255\255\255\255\074\001\075\001\255\255\255\255\
\017\001\079\001\080\001\081\001\082\001\083\001\010\001\011\001\
\012\001\013\001\014\001\015\001\016\001\017\001\255\255\255\255\
\255\255\255\255\060\001\255\255\062\001\063\001\064\001\255\255\
\255\255\067\001\255\255\069\001\255\255\071\001\010\001\011\001\
\012\001\013\001\014\001\015\001\016\001\017\001\255\255\081\001\
\082\001\083\001\255\255\060\001\255\255\062\001\063\001\064\001\
\255\255\255\255\067\001\255\255\069\001\255\255\255\255\255\255\
\060\001\255\255\062\001\063\001\064\001\255\255\255\255\067\001\
\255\255\069\001\083\001\071\001\255\255\255\255\074\001\075\001\
\016\001\017\001\255\255\079\001\080\001\081\001\082\001\083\001\
\060\001\255\255\062\001\063\001\064\001\255\255\255\255\067\001\
\255\255\069\001\255\255\071\001\255\255\255\255\255\255\255\255\
\255\255\255\255\017\001\079\001\080\001\081\001\082\001\083\001\
\010\001\011\001\012\001\013\001\014\001\015\001\016\001\017\001\
\255\255\255\255\255\255\255\255\060\001\255\255\062\001\063\001\
\064\001\255\255\255\255\067\001\255\255\069\001\255\255\071\001\
\010\001\011\001\012\001\013\001\014\001\015\001\016\001\017\001\
\255\255\081\001\082\001\083\001\255\255\060\001\255\255\062\001\
\063\001\064\001\255\255\255\255\067\001\255\255\069\001\255\255\
\255\255\255\255\060\001\255\255\062\001\063\001\064\001\255\255\
\255\255\067\001\255\255\069\001\083\001\071\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\079\001\080\001\081\001\
\082\001\083\001\060\001\005\001\062\001\063\001\064\001\255\255\
\255\255\067\001\255\255\069\001\255\255\071\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\079\001\080\001\081\001\
\082\001\083\001\028\001\029\001\030\001\031\001\032\001\033\001\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\012\001\013\001\014\001\
\015\001\016\001\017\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\066\001\067\001\068\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\076\001\012\001\013\001\014\001\015\001\016\001\
\017\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\060\001\255\255\062\001\
\063\001\064\001\255\255\255\255\067\001\255\255\069\001\255\255\
\071\001\012\001\013\001\014\001\015\001\016\001\017\001\255\255\
\079\001\080\001\081\001\082\001\083\001\255\255\255\255\255\255\
\255\255\255\255\255\255\060\001\255\255\062\001\063\001\064\001\
\255\255\255\255\067\001\255\255\069\001\255\255\071\001\012\001\
\013\001\014\001\015\001\016\001\017\001\255\255\079\001\080\001\
\081\001\082\001\083\001\255\255\255\255\255\255\255\255\255\255\
\255\255\060\001\255\255\062\001\063\001\064\001\255\255\255\255\
\067\001\255\255\069\001\255\255\071\001\012\001\013\001\014\001\
\015\001\016\001\017\001\255\255\079\001\080\001\081\001\082\001\
\083\001\255\255\255\255\255\255\255\255\255\255\255\255\060\001\
\255\255\062\001\063\001\064\001\255\255\255\255\067\001\255\255\
\069\001\255\255\071\001\014\001\015\001\016\001\017\001\255\255\
\255\255\255\255\079\001\080\001\081\001\082\001\083\001\255\255\
\255\255\255\255\255\255\255\255\255\255\060\001\255\255\062\001\
\063\001\064\001\255\255\255\255\067\001\255\255\069\001\255\255\
\071\001\014\001\015\001\016\001\017\001\255\255\255\255\255\255\
\079\001\080\001\081\001\082\001\083\001\255\255\255\255\255\255\
\255\255\060\001\255\255\062\001\063\001\064\001\255\255\255\255\
\067\001\255\255\069\001\255\255\071\001\014\001\015\001\016\001\
\017\001\255\255\255\255\255\255\255\255\255\255\081\001\082\001\
\083\001\016\001\017\001\255\255\255\255\255\255\255\255\060\001\
\255\255\062\001\063\001\064\001\255\255\255\255\067\001\255\255\
\069\001\255\255\071\001\255\255\255\255\255\255\255\255\255\255\
\255\255\016\001\017\001\255\255\081\001\082\001\083\001\255\255\
\255\255\016\001\017\001\060\001\255\255\062\001\063\001\064\001\
\255\255\255\255\067\001\255\255\069\001\060\001\071\001\062\001\
\063\001\064\001\016\001\017\001\067\001\255\255\069\001\255\255\
\081\001\082\001\083\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\081\001\082\001\083\001\060\001\255\255\062\001\
\063\001\064\001\255\255\255\255\067\001\060\001\069\001\062\001\
\063\001\064\001\255\255\255\255\067\001\255\255\069\001\255\255\
\255\255\255\255\081\001\082\001\083\001\255\255\060\001\255\255\
\062\001\063\001\064\001\082\001\083\001\067\001\002\001\069\001\
\255\255\005\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\082\001\083\001\255\255\255\255\
\255\255\255\255\255\255\255\255\005\001\255\255\255\255\255\255\
\028\001\029\001\030\001\031\001\032\001\033\001\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\028\001\029\001\030\001\031\001\032\001\
\033\001\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\005\001\067\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\060\001\061\001\255\255\063\001\064\001\
\065\001\066\001\067\001\068\001\255\255\028\001\029\001\030\001\
\031\001\032\001\033\001\034\001\035\001\036\001\037\001\038\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\005\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\060\001\061\001\255\255\
\063\001\064\001\065\001\255\255\067\001\255\255\255\255\028\001\
\029\001\030\001\031\001\032\001\033\001\034\001\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\005\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\060\001\
\061\001\255\255\063\001\064\001\065\001\005\001\067\001\255\255\
\255\255\028\001\029\001\030\001\031\001\032\001\033\001\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\028\001\029\001\030\001\031\001\
\032\001\033\001\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\005\001\
\067\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\061\001\005\001\255\255\
\255\255\065\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\033\001\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\005\001\033\001\034\001\035\001\036\001\037\001\038\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\062\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\028\001\029\001\030\001\031\001\032\001\033\001\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\005\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\061\001\255\255\255\255\255\255\255\255\255\255\005\001\
\255\255\255\255\028\001\029\001\030\001\031\001\032\001\033\001\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\028\001\029\001\
\030\001\031\001\032\001\033\001\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001"

let yynames_const = "\
  SIZEOF\000\
  PTR_OP\000\
  INC_OP\000\
  DEC_OP\000\
  LEFT_OP\000\
  RIGHT_OP\000\
  LE_OP\000\
  GE_OP\000\
  EQ_OP\000\
  NE_OP\000\
  AND_OP\000\
  OR_OP\000\
  MUL_ASSIGN\000\
  DIV_ASSIGN\000\
  MOD_ASSIGN\000\
  ADD_ASSIGN\000\
  SUB_ASSIGN\000\
  LEFT_ASSIGN\000\
  RIGHT_ASSIGN\000\
  AND_ASSIGN\000\
  XOR_ASSIGN\000\
  OR_ASSIGN\000\
  TYPEDEF\000\
  EXTERN\000\
  STATIC\000\
  AUTO\000\
  REGISTER\000\
  CHAR\000\
  SHORT\000\
  INT\000\
  LONG\000\
  SIGNED\000\
  UNSIGNED\000\
  FLOAT\000\
  DOUBLE\000\
  CONST\000\
  VOLATILE\000\
  VOID\000\
  STRUCT\000\
  UNION\000\
  ENUM\000\
  ELLIPSIS\000\
  CASE\000\
  DEFAULT\000\
  IF\000\
  ELSE\000\
  SWITCH\000\
  WHILE\000\
  DO\000\
  FOR\000\
  GOTO\000\
  CONTINUE\000\
  BREAK\000\
  RETURN\000\
  SEMICOLON\000\
  LBRACE\000\
  RBRACE\000\
  COMMA\000\
  COLON\000\
  EQUAL\000\
  LPAR\000\
  RPAR\000\
  LSQUARE\000\
  RSQUARE\000\
  DOT\000\
  AMP\000\
  EXL\000\
  TILDE\000\
  MINUS\000\
  PLUS\000\
  STAR\000\
  SLASH\000\
  PERCENT\000\
  LT\000\
  GT\000\
  HAT\000\
  PIPE\000\
  QUESTION\000\
  EOF\000\
  "

let yynames_block = "\
  ANNOT\000\
  IDENTIFIER\000\
  CONSTANT\000\
  STRING_LITERAL\000\
  TYPE_NAME\000\
  "

let yyact = [|
  (fun _ -> failwith "parser")
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'translation_unit) in
    Obj.repr((
# 70 "src/cparser.mly"
                                 _1 ) : Cast.file))
; (fun parser_env ->
    Obj.repr((
# 71 "src/cparser.mly"
                [] ) : Cast.file))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 75 "src/cparser.mly"
                       CEvar (loc (), Ident.create _1) ) : 'primary_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 76 "src/cparser.mly"
                     CEconst (loc (), _1) ) : 'primary_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 77 "src/cparser.mly"
                           uns() ) : 'primary_expression))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'expression) in
    Obj.repr((
# 78 "src/cparser.mly"
                                 _2 ) : 'primary_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'primary_expression) in
    Obj.repr((
# 83 "src/cparser.mly"
              _1 ) : 'postfix_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'postfix_expression) in
    let _3 = (peek_val parser_env 1 : 'expression) in
    Obj.repr((
# 85 "src/cparser.mly"
       CEarrget (loc (), _1, _3) ) : 'postfix_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'postfix_expression) in
    Obj.repr((
# 87 "src/cparser.mly"
       CEcall (loc (), _1, []) ) : 'postfix_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'postfix_expression) in
    let _3 = (peek_val parser_env 1 : 'argument_expression_list) in
    Obj.repr((
# 89 "src/cparser.mly"
       CEcall (loc (), _1, _3) ) : 'postfix_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'postfix_expression) in
    let _3 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 91 "src/cparser.mly"
       uns () ) : 'postfix_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'postfix_expression) in
    let _3 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 93 "src/cparser.mly"
       uns() ) : 'postfix_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'postfix_expression) in
    Obj.repr((
# 95 "src/cparser.mly"
       CEunary (loc (), Postfix_inc, _1) ) : 'postfix_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'postfix_expression) in
    Obj.repr((
# 97 "src/cparser.mly"
       CEunary (loc (), Postfix_dec, _1)) : 'postfix_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'assignment_expression) in
    Obj.repr((
# 101 "src/cparser.mly"
                                  [_1] ) : 'argument_expression_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'argument_expression_list) in
    let _3 = (peek_val parser_env 0 : 'assignment_expression) in
    Obj.repr((
# 102 "src/cparser.mly"
                                                                 _1 @ [_3] ) : 'argument_expression_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'postfix_expression) in
    Obj.repr((
# 106 "src/cparser.mly"
                               _1 ) : 'unary_expression))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'unary_expression) in
    Obj.repr((
# 107 "src/cparser.mly"
                                    CEunary (loc (), Prefix_inc, _2) ) : 'unary_expression))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'unary_expression) in
    Obj.repr((
# 108 "src/cparser.mly"
                                    CEunary (loc (), Prefix_dec, _2) ) : 'unary_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'unary_operator) in
    let _2 = (peek_val parser_env 0 : 'cast_expression) in
    Obj.repr((
# 109 "src/cparser.mly"
                                           CEunary (loc (), _1, _2) ) : 'unary_expression))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'unary_expression) in
    Obj.repr((
# 110 "src/cparser.mly"
                                    uns () ) : 'unary_expression))
; (fun parser_env ->
    let _3 = (peek_val parser_env 1 : 'type_name) in
    Obj.repr((
# 111 "src/cparser.mly"
                                       uns () ) : 'unary_expression))
; (fun parser_env ->
    Obj.repr((
# 115 "src/cparser.mly"
                Uamp ) : 'unary_operator))
; (fun parser_env ->
    Obj.repr((
# 116 "src/cparser.mly"
                 Ustar ) : 'unary_operator))
; (fun parser_env ->
    Obj.repr((
# 117 "src/cparser.mly"
                 Uplus ) : 'unary_operator))
; (fun parser_env ->
    Obj.repr((
# 118 "src/cparser.mly"
                  Uminus ) : 'unary_operator))
; (fun parser_env ->
    Obj.repr((
# 119 "src/cparser.mly"
                  uns () ) : 'unary_operator))
; (fun parser_env ->
    Obj.repr((
# 120 "src/cparser.mly"
                Not ) : 'unary_operator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'unary_expression) in
    Obj.repr((
# 124 "src/cparser.mly"
                             _1 ) : 'cast_expression))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : 'type_name) in
    let _4 = (peek_val parser_env 0 : 'cast_expression) in
    Obj.repr((
# 125 "src/cparser.mly"
                                                uns () ) : 'cast_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'cast_expression) in
    Obj.repr((
# 130 "src/cparser.mly"
              _1 ) : 'multiplicative_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'multiplicative_expression) in
    let _3 = (peek_val parser_env 0 : 'cast_expression) in
    Obj.repr((
# 132 "src/cparser.mly"
       CEbinary (loc (), _1, Mult, _3) ) : 'multiplicative_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'multiplicative_expression) in
    let _3 = (peek_val parser_env 0 : 'cast_expression) in
    Obj.repr((
# 134 "src/cparser.mly"
       CEbinary (loc (), _1, Div, _3) ) : 'multiplicative_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'multiplicative_expression) in
    let _3 = (peek_val parser_env 0 : 'cast_expression) in
    Obj.repr((
# 136 "src/cparser.mly"
       CEbinary (loc (), _1, Mod, _3) ) : 'multiplicative_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'multiplicative_expression) in
    Obj.repr((
# 141 "src/cparser.mly"
             _1 ) : 'additive_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'additive_expression) in
    let _3 = (peek_val parser_env 0 : 'multiplicative_expression) in
    Obj.repr((
# 143 "src/cparser.mly"
       CEbinary (loc (), _1, Plus, _3) ) : 'additive_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'additive_expression) in
    let _3 = (peek_val parser_env 0 : 'multiplicative_expression) in
    Obj.repr((
# 145 "src/cparser.mly"
       CEbinary (loc (), _1, Minus, _3) ) : 'additive_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'additive_expression) in
    Obj.repr((
# 149 "src/cparser.mly"
                                _1 ) : 'shift_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'shift_expression) in
    let _3 = (peek_val parser_env 0 : 'additive_expression) in
    Obj.repr((
# 150 "src/cparser.mly"
                                                         uns () ) : 'shift_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'shift_expression) in
    let _3 = (peek_val parser_env 0 : 'additive_expression) in
    Obj.repr((
# 151 "src/cparser.mly"
                                                          uns () ) : 'shift_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'shift_expression) in
    Obj.repr((
# 156 "src/cparser.mly"
              _1 ) : 'relational_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'relational_expression) in
    let _3 = (peek_val parser_env 0 : 'shift_expression) in
    Obj.repr((
# 158 "src/cparser.mly"
       CEbinary (loc (), _1, Lt, _3) ) : 'relational_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'relational_expression) in
    let _3 = (peek_val parser_env 0 : 'shift_expression) in
    Obj.repr((
# 160 "src/cparser.mly"
       CEbinary (loc (), _1, Gt, _3) ) : 'relational_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'relational_expression) in
    let _3 = (peek_val parser_env 0 : 'shift_expression) in
    Obj.repr((
# 162 "src/cparser.mly"
       CEbinary (loc (), _1, Le, _3) ) : 'relational_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'relational_expression) in
    let _3 = (peek_val parser_env 0 : 'shift_expression) in
    Obj.repr((
# 164 "src/cparser.mly"
       CEbinary (loc (), _1, Ge, _3) ) : 'relational_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'relational_expression) in
    Obj.repr((
# 169 "src/cparser.mly"
              _1 ) : 'equality_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'equality_expression) in
    let _3 = (peek_val parser_env 0 : 'relational_expression) in
    Obj.repr((
# 171 "src/cparser.mly"
       CEbinary (loc (), _1, Eq, _3) ) : 'equality_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'equality_expression) in
    let _3 = (peek_val parser_env 0 : 'relational_expression) in
    Obj.repr((
# 173 "src/cparser.mly"
       CEbinary (loc (), _1, Neq, _3) ) : 'equality_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'equality_expression) in
    Obj.repr((
# 178 "src/cparser.mly"
              _1 ) : 'and_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'and_expression) in
    let _3 = (peek_val parser_env 0 : 'equality_expression) in
    Obj.repr((
# 180 "src/cparser.mly"
       CEbinary (loc (), _1, Bw_and, _3) ) : 'and_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'and_expression) in
    Obj.repr((
# 185 "src/cparser.mly"
              _1 ) : 'exclusive_or_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'exclusive_or_expression) in
    let _3 = (peek_val parser_env 0 : 'and_expression) in
    Obj.repr((
# 187 "src/cparser.mly"
       CEbinary (loc (), _1, Bw_xor, _3) ) : 'exclusive_or_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'exclusive_or_expression) in
    Obj.repr((
# 192 "src/cparser.mly"
              _1 ) : 'inclusive_or_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'inclusive_or_expression) in
    let _3 = (peek_val parser_env 0 : 'exclusive_or_expression) in
    Obj.repr((
# 194 "src/cparser.mly"
       CEbinary (loc (), _1, Bw_or, _3) ) : 'inclusive_or_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'inclusive_or_expression) in
    Obj.repr((
# 199 "src/cparser.mly"
              _1 ) : 'logical_and_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'logical_and_expression) in
    let _3 = (peek_val parser_env 0 : 'inclusive_or_expression) in
    Obj.repr((
# 201 "src/cparser.mly"
       CEbinary (loc (), _1, And, _3) ) : 'logical_and_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'logical_and_expression) in
    Obj.repr((
# 206 "src/cparser.mly"
              _1 ) : 'logical_or_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'logical_or_expression) in
    let _3 = (peek_val parser_env 0 : 'logical_and_expression) in
    Obj.repr((
# 208 "src/cparser.mly"
       CEbinary (loc (), _1, Or, _3) ) : 'logical_or_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'logical_or_expression) in
    Obj.repr((
# 213 "src/cparser.mly"
              _1 ) : 'conditional_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 4 : 'logical_or_expression) in
    let _3 = (peek_val parser_env 2 : 'expression) in
    let _5 = (peek_val parser_env 0 : 'conditional_expression) in
    Obj.repr((
# 215 "src/cparser.mly"
       CEcond (loc (), _1, _3, _5) ) : 'conditional_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'conditional_expression) in
    Obj.repr((
# 220 "src/cparser.mly"
              _1 ) : 'assignment_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'unary_expression) in
    let _2 = (peek_val parser_env 1 : 'assignment_operator) in
    let _3 = (peek_val parser_env 0 : 'assignment_expression) in
    Obj.repr((
# 222 "src/cparser.mly"
       CEassign (loc (), _1, _2, _3) ) : 'assignment_expression))
; (fun parser_env ->
    Obj.repr((
# 226 "src/cparser.mly"
                  Aequal ) : 'assignment_operator))
; (fun parser_env ->
    Obj.repr((
# 227 "src/cparser.mly"
                       Amul ) : 'assignment_operator))
; (fun parser_env ->
    Obj.repr((
# 228 "src/cparser.mly"
                       Adiv ) : 'assignment_operator))
; (fun parser_env ->
    Obj.repr((
# 229 "src/cparser.mly"
                       Amod ) : 'assignment_operator))
; (fun parser_env ->
    Obj.repr((
# 230 "src/cparser.mly"
                       Aadd ) : 'assignment_operator))
; (fun parser_env ->
    Obj.repr((
# 231 "src/cparser.mly"
                       Asub ) : 'assignment_operator))
; (fun parser_env ->
    Obj.repr((
# 232 "src/cparser.mly"
                        Aleft ) : 'assignment_operator))
; (fun parser_env ->
    Obj.repr((
# 233 "src/cparser.mly"
                         Aright ) : 'assignment_operator))
; (fun parser_env ->
    Obj.repr((
# 234 "src/cparser.mly"
                       Aand ) : 'assignment_operator))
; (fun parser_env ->
    Obj.repr((
# 235 "src/cparser.mly"
                       Axor ) : 'assignment_operator))
; (fun parser_env ->
    Obj.repr((
# 236 "src/cparser.mly"
                      Aor ) : 'assignment_operator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'assignment_expression) in
    Obj.repr((
# 240 "src/cparser.mly"
                                  _1 ) : 'expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'expression) in
    let _3 = (peek_val parser_env 0 : 'assignment_expression) in
    Obj.repr((
# 241 "src/cparser.mly"
                                                   CEseq (loc(), _1, _3) ) : 'expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'conditional_expression) in
    Obj.repr((
# 245 "src/cparser.mly"
                                   _1 ) : 'constant_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'declaration_specifiers) in
    Obj.repr((
# 249 "src/cparser.mly"
                                             uns() ) : 'declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'declaration_specifiers) in
    let _2 = (peek_val parser_env 1 : 'init_declarator_list) in
    Obj.repr((
# 251 "src/cparser.mly"
       List.map (fun (p,d) -> 
			  let v = if p then CTpointer _1 else _1 in
			  Ctypedecl (loc(), d, v)) _2 ) : 'declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'storage_class_specifier) in
    Obj.repr((
# 257 "src/cparser.mly"
                                    uns() ) : 'declaration_specifiers))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'storage_class_specifier) in
    let _2 = (peek_val parser_env 0 : 'declaration_specifiers) in
    Obj.repr((
# 258 "src/cparser.mly"
                                                           uns() ) : 'declaration_specifiers))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'type_specifier) in
    Obj.repr((
# 259 "src/cparser.mly"
                           _1 ) : 'declaration_specifiers))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'type_specifier) in
    let _2 = (peek_val parser_env 0 : 'declaration_specifiers) in
    Obj.repr((
# 260 "src/cparser.mly"
                                                  uns() ) : 'declaration_specifiers))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'type_qualifier) in
    Obj.repr((
# 261 "src/cparser.mly"
                           uns() ) : 'declaration_specifiers))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'type_qualifier) in
    let _2 = (peek_val parser_env 0 : 'declaration_specifiers) in
    Obj.repr((
# 262 "src/cparser.mly"
                                                  uns() ) : 'declaration_specifiers))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'init_declarator) in
    Obj.repr((
# 266 "src/cparser.mly"
                            [_1] ) : 'init_declarator_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'init_declarator_list) in
    let _3 = (peek_val parser_env 0 : 'init_declarator) in
    Obj.repr((
# 267 "src/cparser.mly"
                                                       _1 @ [_3] ) : 'init_declarator_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'declarator) in
    Obj.repr((
# 272 "src/cparser.mly"
              _1 ) : 'init_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'declarator) in
    let _3 = (peek_val parser_env 0 : 'c_initializer) in
    Obj.repr((
# 274 "src/cparser.mly"
       match _1 with 
		| p, CDvar (id, _) -> p, CDvar (id, Some _3) 
		| d -> d 
	    ) : 'init_declarator))
; (fun parser_env ->
    Obj.repr((
# 281 "src/cparser.mly"
                    ) : 'storage_class_specifier))
; (fun parser_env ->
    Obj.repr((
# 282 "src/cparser.mly"
                   ) : 'storage_class_specifier))
; (fun parser_env ->
    Obj.repr((
# 283 "src/cparser.mly"
                   ) : 'storage_class_specifier))
; (fun parser_env ->
    Obj.repr((
# 284 "src/cparser.mly"
                 ) : 'storage_class_specifier))
; (fun parser_env ->
    Obj.repr((
# 285 "src/cparser.mly"
                     ) : 'storage_class_specifier))
; (fun parser_env ->
    Obj.repr((
# 289 "src/cparser.mly"
                 CTpure PTunit ) : 'type_specifier))
; (fun parser_env ->
    Obj.repr((
# 290 "src/cparser.mly"
                 CTpure PTint ) : 'type_specifier))
; (fun parser_env ->
    Obj.repr((
# 291 "src/cparser.mly"
                  CTpure PTint ) : 'type_specifier))
; (fun parser_env ->
    Obj.repr((
# 292 "src/cparser.mly"
                CTpure PTint ) : 'type_specifier))
; (fun parser_env ->
    Obj.repr((
# 293 "src/cparser.mly"
                 CTpure PTint ) : 'type_specifier))
; (fun parser_env ->
    Obj.repr((
# 294 "src/cparser.mly"
                  CTpure PTfloat ) : 'type_specifier))
; (fun parser_env ->
    Obj.repr((
# 295 "src/cparser.mly"
                   CTpure PTfloat ) : 'type_specifier))
; (fun parser_env ->
    Obj.repr((
# 296 "src/cparser.mly"
                   uns() ) : 'type_specifier))
; (fun parser_env ->
    Obj.repr((
# 297 "src/cparser.mly"
                     uns() ) : 'type_specifier))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'struct_or_union_specifier) in
    Obj.repr((
# 298 "src/cparser.mly"
                                      uns() ) : 'type_specifier))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'enum_specifier) in
    Obj.repr((
# 299 "src/cparser.mly"
                           uns() ) : 'type_specifier))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 300 "src/cparser.mly"
                      CTpure (PTexternal (Ident.create _1)) ) : 'type_specifier))
; (fun parser_env ->
    let _1 = (peek_val parser_env 4 : 'struct_or_union) in
    let _2 = (peek_val parser_env 3 : string) in
    let _4 = (peek_val parser_env 1 : 'struct_declaration_list) in
    Obj.repr((
# 304 "src/cparser.mly"
                                                                             ) : 'struct_or_union_specifier))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'struct_or_union) in
    let _3 = (peek_val parser_env 1 : 'struct_declaration_list) in
    Obj.repr((
# 305 "src/cparser.mly"
                                                                  ) : 'struct_or_union_specifier))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'struct_or_union) in
    let _2 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 306 "src/cparser.mly"
                                       ) : 'struct_or_union_specifier))
; (fun parser_env ->
    Obj.repr((
# 310 "src/cparser.mly"
                   ) : 'struct_or_union))
; (fun parser_env ->
    Obj.repr((
# 311 "src/cparser.mly"
                  ) : 'struct_or_union))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'struct_declaration) in
    Obj.repr((
# 315 "src/cparser.mly"
                               ) : 'struct_declaration_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'struct_declaration_list) in
    let _2 = (peek_val parser_env 0 : 'struct_declaration) in
    Obj.repr((
# 316 "src/cparser.mly"
                                                       ) : 'struct_declaration_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'specifier_qualifier_list) in
    let _2 = (peek_val parser_env 1 : 'struct_declarator_list) in
    Obj.repr((
# 320 "src/cparser.mly"
                                                                      ) : 'struct_declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'type_specifier) in
    let _2 = (peek_val parser_env 0 : 'specifier_qualifier_list) in
    Obj.repr((
# 324 "src/cparser.mly"
                                                    ) : 'specifier_qualifier_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'type_specifier) in
    Obj.repr((
# 325 "src/cparser.mly"
                           ) : 'specifier_qualifier_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'type_qualifier) in
    let _2 = (peek_val parser_env 0 : 'specifier_qualifier_list) in
    Obj.repr((
# 326 "src/cparser.mly"
                                                    ) : 'specifier_qualifier_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'type_qualifier) in
    Obj.repr((
# 327 "src/cparser.mly"
                           ) : 'specifier_qualifier_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'struct_declarator) in
    Obj.repr((
# 331 "src/cparser.mly"
                              ) : 'struct_declarator_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'struct_declarator_list) in
    let _3 = (peek_val parser_env 0 : 'struct_declarator) in
    Obj.repr((
# 332 "src/cparser.mly"
                                                           ) : 'struct_declarator_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'declarator) in
    Obj.repr((
# 336 "src/cparser.mly"
                       ) : 'struct_declarator))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'constant_expression) in
    Obj.repr((
# 337 "src/cparser.mly"
                                      ) : 'struct_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'declarator) in
    let _3 = (peek_val parser_env 0 : 'constant_expression) in
    Obj.repr((
# 338 "src/cparser.mly"
                                                 ) : 'struct_declarator))
; (fun parser_env ->
    let _3 = (peek_val parser_env 1 : 'enumerator_list) in
    Obj.repr((
# 342 "src/cparser.mly"
                                               ) : 'enum_specifier))
; (fun parser_env ->
    let _2 = (peek_val parser_env 3 : string) in
    let _4 = (peek_val parser_env 1 : 'enumerator_list) in
    Obj.repr((
# 343 "src/cparser.mly"
                                                          ) : 'enum_specifier))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 344 "src/cparser.mly"
                            ) : 'enum_specifier))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'enumerator) in
    Obj.repr((
# 348 "src/cparser.mly"
                       ) : 'enumerator_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'enumerator_list) in
    let _3 = (peek_val parser_env 0 : 'enumerator) in
    Obj.repr((
# 349 "src/cparser.mly"
                                             ) : 'enumerator_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 353 "src/cparser.mly"
                       ) : 'enumerator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : string) in
    let _3 = (peek_val parser_env 0 : 'constant_expression) in
    Obj.repr((
# 354 "src/cparser.mly"
                                                 ) : 'enumerator))
; (fun parser_env ->
    Obj.repr((
# 358 "src/cparser.mly"
                  ) : 'type_qualifier))
; (fun parser_env ->
    Obj.repr((
# 359 "src/cparser.mly"
                     ) : 'type_qualifier))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'pointer) in
    let _2 = (peek_val parser_env 0 : 'direct_declarator) in
    Obj.repr((
# 363 "src/cparser.mly"
                                      true, _2 ) : 'declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'direct_declarator) in
    Obj.repr((
# 364 "src/cparser.mly"
                              false, _1 ) : 'declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 369 "src/cparser.mly"
              CDvar (Ident.create _1, None) ) : 'direct_declarator))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'declarator) in
    Obj.repr((
# 371 "src/cparser.mly"
       uns() ) : 'direct_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'direct_declarator) in
    let _3 = (peek_val parser_env 1 : 'constant_expression) in
    Obj.repr((
# 373 "src/cparser.mly"
       uns() ) : 'direct_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'direct_declarator) in
    Obj.repr((
# 375 "src/cparser.mly"
       match _1 with CDvar (id,_) -> CDarr (id, None) | _ -> uns () ) : 'direct_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 4 : 'direct_declarator) in
    let _3 = (peek_val parser_env 2 : 'parameter_type_list) in
    let _5 = (peek_val parser_env 0 : 'annot) in
    Obj.repr((
# 377 "src/cparser.mly"
       match _1 with CDvar (id,_) -> CDfun (id, _3, _5) | _ -> uns () ) : 'direct_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'direct_declarator) in
    let _3 = (peek_val parser_env 1 : 'identifier_list) in
    Obj.repr((
# 379 "src/cparser.mly"
       uns() ) : 'direct_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'direct_declarator) in
    let _4 = (peek_val parser_env 0 : 'annot) in
    Obj.repr((
# 381 "src/cparser.mly"
              match _1 with CDvar (id,_) -> CDfun (id, [], _4) | _ -> uns () ) : 'direct_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : int * string) in
    Obj.repr((
# 386 "src/cparser.mly"
                          Some _1 ) : 'annot))
; (fun parser_env ->
    Obj.repr((
# 387 "src/cparser.mly"
                          None ) : 'annot))
; (fun parser_env ->
    Obj.repr((
# 391 "src/cparser.mly"
                 () ) : 'pointer))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'type_qualifier_list) in
    Obj.repr((
# 392 "src/cparser.mly"
                                     uns () ) : 'pointer))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'pointer) in
    Obj.repr((
# 393 "src/cparser.mly"
                         uns () ) : 'pointer))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'type_qualifier_list) in
    let _3 = (peek_val parser_env 0 : 'pointer) in
    Obj.repr((
# 394 "src/cparser.mly"
                                             uns () ) : 'pointer))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'type_qualifier) in
    Obj.repr((
# 398 "src/cparser.mly"
                           ) : 'type_qualifier_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'type_qualifier_list) in
    let _2 = (peek_val parser_env 0 : 'type_qualifier) in
    Obj.repr((
# 399 "src/cparser.mly"
                                               ) : 'type_qualifier_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'parameter_list) in
    Obj.repr((
# 404 "src/cparser.mly"
                           _1 ) : 'parameter_type_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'parameter_list) in
    Obj.repr((
# 405 "src/cparser.mly"
                                          uns() ) : 'parameter_type_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'parameter_declaration) in
    Obj.repr((
# 409 "src/cparser.mly"
                                  [_1] ) : 'parameter_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'parameter_list) in
    let _3 = (peek_val parser_env 0 : 'parameter_declaration) in
    Obj.repr((
# 410 "src/cparser.mly"
                                                       _1 @ [_3] ) : 'parameter_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'declaration_specifiers) in
    let _2 = (peek_val parser_env 0 : 'declarator) in
    Obj.repr((
# 415 "src/cparser.mly"
              match _2 with 
		| false, CDvar (id, _) -> _1, id 
		| true, CDvar (id, _) -> CTpointer _1, id 
		| false, CDarr (id, _) -> CTarray _1, id
		| _ -> uns() ) : 'parameter_declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'declaration_specifiers) in
    let _2 = (peek_val parser_env 0 : 'abstract_declarator) in
    Obj.repr((
# 420 "src/cparser.mly"
                                                       uns() ) : 'parameter_declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'declaration_specifiers) in
    Obj.repr((
# 421 "src/cparser.mly"
                                   (_1, Ident.anonymous) ) : 'parameter_declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 425 "src/cparser.mly"
                       ) : 'identifier_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'identifier_list) in
    let _3 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 426 "src/cparser.mly"
                                             ) : 'identifier_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'specifier_qualifier_list) in
    Obj.repr((
# 430 "src/cparser.mly"
                                     ) : 'type_name))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'specifier_qualifier_list) in
    let _2 = (peek_val parser_env 0 : 'abstract_declarator) in
    Obj.repr((
# 431 "src/cparser.mly"
                                                         ) : 'type_name))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'pointer) in
    Obj.repr((
# 435 "src/cparser.mly"
                    ) : 'abstract_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'direct_abstract_declarator) in
    Obj.repr((
# 436 "src/cparser.mly"
                                       ) : 'abstract_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'pointer) in
    let _2 = (peek_val parser_env 0 : 'direct_abstract_declarator) in
    Obj.repr((
# 437 "src/cparser.mly"
                                               ) : 'abstract_declarator))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'abstract_declarator) in
    Obj.repr((
# 441 "src/cparser.mly"
                                          ) : 'direct_abstract_declarator))
; (fun parser_env ->
    Obj.repr((
# 442 "src/cparser.mly"
                            ) : 'direct_abstract_declarator))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'constant_expression) in
    Obj.repr((
# 443 "src/cparser.mly"
                                                ) : 'direct_abstract_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'direct_abstract_declarator) in
    Obj.repr((
# 444 "src/cparser.mly"
                                                       ) : 'direct_abstract_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'direct_abstract_declarator) in
    let _3 = (peek_val parser_env 1 : 'constant_expression) in
    Obj.repr((
# 445 "src/cparser.mly"
                                                                           ) : 'direct_abstract_declarator))
; (fun parser_env ->
    Obj.repr((
# 446 "src/cparser.mly"
                      ) : 'direct_abstract_declarator))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'parameter_type_list) in
    Obj.repr((
# 447 "src/cparser.mly"
                                          ) : 'direct_abstract_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'direct_abstract_declarator) in
    Obj.repr((
# 448 "src/cparser.mly"
                                                 ) : 'direct_abstract_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'direct_abstract_declarator) in
    let _3 = (peek_val parser_env 1 : 'parameter_type_list) in
    Obj.repr((
# 449 "src/cparser.mly"
                                                                     ) : 'direct_abstract_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'assignment_expression) in
    Obj.repr((
# 453 "src/cparser.mly"
                                  _1 ) : 'c_initializer))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'c_initializer_list) in
    Obj.repr((
# 454 "src/cparser.mly"
                                             uns() ) : 'c_initializer))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : 'c_initializer_list) in
    Obj.repr((
# 455 "src/cparser.mly"
                                                   uns() ) : 'c_initializer))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'c_initializer) in
    Obj.repr((
# 459 "src/cparser.mly"
                          ) : 'c_initializer_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'c_initializer_list) in
    let _3 = (peek_val parser_env 0 : 'c_initializer) in
    Obj.repr((
# 460 "src/cparser.mly"
                                                   ) : 'c_initializer_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'labeled_statement) in
    Obj.repr((
# 464 "src/cparser.mly"
                              _1 ) : 'statement))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'compound_statement) in
    Obj.repr((
# 465 "src/cparser.mly"
                               CSblock (loc (), _1) ) : 'statement))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'expression_statement) in
    Obj.repr((
# 466 "src/cparser.mly"
                                 _1 ) : 'statement))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'selection_statement) in
    Obj.repr((
# 467 "src/cparser.mly"
                                _1 ) : 'statement))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'iteration_statement) in
    Obj.repr((
# 468 "src/cparser.mly"
                                _1 ) : 'statement))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'jump_statement) in
    Obj.repr((
# 469 "src/cparser.mly"
                           _1 ) : 'statement))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : string) in
    let _3 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 473 "src/cparser.mly"
                                       uns () ) : 'labeled_statement))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : 'constant_expression) in
    let _4 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 474 "src/cparser.mly"
                                                     uns () ) : 'labeled_statement))
; (fun parser_env ->
    let _3 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 475 "src/cparser.mly"
                                    uns () ) : 'labeled_statement))
; (fun parser_env ->
    Obj.repr((
# 479 "src/cparser.mly"
                          [], [] ) : 'compound_statement))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'statement_list) in
    Obj.repr((
# 480 "src/cparser.mly"
                                         [], _2 ) : 'compound_statement))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'declaration_list) in
    Obj.repr((
# 481 "src/cparser.mly"
                                           _2, [] ) : 'compound_statement))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : 'declaration_list) in
    let _3 = (peek_val parser_env 1 : 'statement_list) in
    Obj.repr((
# 482 "src/cparser.mly"
                                                          _2, _3 ) : 'compound_statement))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'compound_statement) in
    let _2 = (peek_val parser_env 0 : 'annot) in
    Obj.repr((
# 487 "src/cparser.mly"
                                     (loc (), _1, _2) ) : 'compound_statement_with_post))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'declaration) in
    Obj.repr((
# 491 "src/cparser.mly"
                        _1 ) : 'declaration_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'declaration_list) in
    let _2 = (peek_val parser_env 0 : 'declaration) in
    Obj.repr((
# 492 "src/cparser.mly"
                                         _1 @ _2 ) : 'declaration_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 496 "src/cparser.mly"
                      [_1] ) : 'statement_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'statement_list) in
    let _2 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 497 "src/cparser.mly"
                                     _1 @ [_2] ) : 'statement_list))
; (fun parser_env ->
    Obj.repr((
# 501 "src/cparser.mly"
                      CSnop (loc ()) ) : 'expression_statement))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'expression) in
    Obj.repr((
# 502 "src/cparser.mly"
                                 CSexpr (loc (), _1) ) : 'expression_statement))
; (fun parser_env ->
    let _3 = (peek_val parser_env 2 : 'expression) in
    let _5 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 507 "src/cparser.mly"
              CScond (loc (), _3, _5, CSnop (loc ())) ) : 'selection_statement))
; (fun parser_env ->
    let _3 = (peek_val parser_env 4 : 'expression) in
    let _5 = (peek_val parser_env 2 : 'statement) in
    let _7 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 509 "src/cparser.mly"
       CScond (loc (), _3, _5, _7) ) : 'selection_statement))
; (fun parser_env ->
    let _3 = (peek_val parser_env 2 : 'expression) in
    let _5 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 511 "src/cparser.mly"
       uns () ) : 'selection_statement))
; (fun parser_env ->
    let _3 = (peek_val parser_env 3 : 'expression) in
    let _5 = (peek_val parser_env 1 : int * string) in
    let _6 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 516 "src/cparser.mly"
              CSwhile (loc (), _3, _5, _6) ) : 'iteration_statement))
; (fun parser_env ->
    let _2 = (peek_val parser_env 6 : 'statement) in
    let _3 = (peek_val parser_env 5 : int * string) in
    let _6 = (peek_val parser_env 2 : 'expression) in
    Obj.repr((
# 518 "src/cparser.mly"
       CSdowhile (loc (), _2, _3, _6) ) : 'iteration_statement))
; (fun parser_env ->
    let _3 = (peek_val parser_env 4 : 'expression_statement) in
    let _4 = (peek_val parser_env 3 : 'expression_statement) in
    let _6 = (peek_val parser_env 1 : int * string) in
    let _7 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 520 "src/cparser.mly"
       CSfor (loc (), expr_of_statement _3, expr_of_statement _4, 
		     None, _6, _7) ) : 'iteration_statement))
; (fun parser_env ->
    let _3 = (peek_val parser_env 5 : 'expression_statement) in
    let _4 = (peek_val parser_env 4 : 'expression_statement) in
    let _5 = (peek_val parser_env 3 : 'expression) in
    let _7 = (peek_val parser_env 1 : int * string) in
    let _8 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 523 "src/cparser.mly"
       CSfor (loc (), expr_of_statement _3, expr_of_statement _4, 
		     Some _5, _7, _8) ) : 'iteration_statement))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : string) in
    Obj.repr((
# 528 "src/cparser.mly"
                                      uns () ) : 'jump_statement))
; (fun parser_env ->
    Obj.repr((
# 529 "src/cparser.mly"
                               CScontinue (loc ()) ) : 'jump_statement))
; (fun parser_env ->
    Obj.repr((
# 530 "src/cparser.mly"
                            CSbreak (loc ()) ) : 'jump_statement))
; (fun parser_env ->
    Obj.repr((
# 531 "src/cparser.mly"
                             CSreturn (loc (), None) ) : 'jump_statement))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'expression) in
    Obj.repr((
# 532 "src/cparser.mly"
                                        CSreturn (loc (), Some _2) ) : 'jump_statement))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'external_declaration) in
    Obj.repr((
# 536 "src/cparser.mly"
                                 _1 ) : 'translation_unit))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'translation_unit) in
    let _2 = (peek_val parser_env 0 : 'external_declaration) in
    Obj.repr((
# 537 "src/cparser.mly"
                                                  _1 @ _2 ) : 'translation_unit))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'function_definition) in
    Obj.repr((
# 541 "src/cparser.mly"
                                [_1] ) : 'external_declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'declaration) in
    Obj.repr((
# 542 "src/cparser.mly"
                        _1 ) : 'external_declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'declaration_specifiers) in
    let _2 = (peek_val parser_env 2 : 'declarator) in
    let _3 = (peek_val parser_env 1 : 'declaration_list) in
    let _4 = (peek_val parser_env 0 : 'compound_statement) in
    Obj.repr((
# 547 "src/cparser.mly"
              uns () ) : 'function_definition))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'declaration_specifiers) in
    let _2 = (peek_val parser_env 1 : 'declarator) in
    let _3 = (peek_val parser_env 0 : 'compound_statement_with_post) in
    Obj.repr((
# 549 "src/cparser.mly"
       let (lb,b,q) = _3 in
              match _2 with
		| false, CDfun (id, pl, p) -> 
		    let lb = add_pre_loc lb p in
		    Cfundef (loc (), id, pl, _1, (lb,p,b,q))
		| _ -> uns () ) : 'function_definition))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'declarator) in
    let _2 = (peek_val parser_env 1 : 'declaration_list) in
    let _3 = (peek_val parser_env 0 : 'compound_statement) in
    Obj.repr((
# 556 "src/cparser.mly"
       uns () ) : 'function_definition))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'declarator) in
    let _2 = (peek_val parser_env 0 : 'compound_statement) in
    Obj.repr((
# 558 "src/cparser.mly"
       uns () ) : 'function_definition))
(* Entry file *)
; (fun parser_env -> raise (YYexit (peek_val parser_env 0)))
|]
let yytables =
  { actions=yyact;
    transl_const=yytransl_const;
    transl_block=yytransl_block;
    lhs=yylhs;
    len=yylen;
    defred=yydefred;
    dgoto=yydgoto;
    sindex=yysindex;
    rindex=yyrindex;
    gindex=yygindex;
    tablesize=yytablesize;
    table=yytable;
    check=yycheck;
    error_function=parse_error;
    names_const=yynames_const;
    names_block=yynames_block }
let file (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (yyparse yytables 1 lexfun lexbuf : Cast.file)
